--[[
	I haven't had time to really make this more efficient, however I'm sure I've fixed all the bugs.
--]]
ware={}
parse("mp_damagefactor 0")
parse("mp_roundtime 99")
parse("sv_gm 1")
pathTo="gfx/Warehouse/"
images={
	"",
	"wall.png",
	"floor.png",
	"crate_light.png",
	"indicate.png",
	"crate_dark.png",
	"floor.png"
}
--[[
0=Empty
1=Wall
2=Floor
3=Crate
4=indicate
5=crate&indicate
6=spawn
--]]
ware.levels={
	{
		{0,0,1,1,1,1,1,0},
		{1,1,1,2,2,2,1,0},
		{1,4,6,3,2,2,1,0},
		{1,1,1,2,3,4,1,0},
		{1,4,1,1,3,2,1,0},
		{1,2,1,2,4,2,1,1},
		{1,3,2,5,3,3,4,1},
		{1,2,2,2,4,2,2,1},
		{1,1,1,1,1,1,1,1}
	}
}
addhook("startround","ware.startround")
function ware.startround()
	if imgLocation~=nil then
		for _,y in ipairs(imgLocation) do
			for _,x in ipairs(y) do
				freeimage(x)
			end
		end
	end
	for _,obj in ipairs(object(0,"table")) do
		parse("killobject "..obj)
	end
	level=math.random(1,#ware.levels)
	tmpLevel=ware.levels[level]
	imgLocation={}
	x=0
	y=0
	for _,row in ipairs(tmpLevel) do
		for _,block in ipairs(row) do
			if block==1 then
				parse("spawnobject 4 ".." "..x.." "..y)
				image(pathTo..images[2],x*32+16,y*32+16,3)
			elseif block==2 then
				image(pathTo..images[3],x*32+16,y*32+16,0)	
			elseif block==3 then
				parse("spawnobject 4 ".." "..x.." "..y)
				imgLocation[x.." "..y]=image(pathTo..images[4],x*32+16,y*32+16,3)
				image(pathTo..images[3],x*32+16,y*32+16,0)
			elseif block==4 then
				image(pathTo..images[5],x*32+16,y*32+16,0)	
			elseif block==5 then
				parse("spawnobject 4 ".." "..x.." "..y)
				imgLocation[x.." "..y]=image(pathTo..images[6],x*32+16,y*32+16,3)
				image(pathTo..images[5],x*32+16,y*32+16,0)
			elseif block==6 then
				image(pathTo..images[7],x*32+16,y*32+16,0)
				spawn={x,y}
				tmpLevel[y+1][x+1]=2
			end
			x=x+1
		end
		y=y+1
		x=0
	end
end
addhook("attack","ware.attack")
function ware.attack(id)
	if player(id,"rot")>=-45 and player(id,"rot")<=45 then
		if tmpLevel[player(id,"tiley")][player(id,"tilex")+1]==3 or tmpLevel[player(id,"tiley")][player(id,"tilex")+1]==5 then
			if tmpLevel[player(id,"tiley")-1][player(id,"tilex")+1]==2 or tmpLevel[player(id,"tiley")-1][player(id,"tilex")+1]==4 then
				if tmpLevel[player(id,"tiley")][player(id,"tilex")+1]==5 then
					tmpLevel[player(id,"tiley")-1][player(id,"tilex")]=4
				else
					tmpLevel[player(id,"tiley")-1][player(id,"tilex")]=2
				end
				parse("killobject "..wallID(player(id,"tilex"),player(id,"tiley")-1,"id"))
				freeimage(imgLocation[(player(id,"tilex")).." "..player(id,"tiley")-1])
				imgLocation[(player(id,"tilex")).." "..player(id,"tiley")-1]=nil
				parse("spawnobject 4 "..(player(id,"tilex")).." "..player(id,"tiley")-2)
				if tmpLevel[player(id,"tiley")-1][player(id,"tilex")+1]==4 then
					imgLocation[player(id,"tilex").." "..player(id,"tiley")-2]=image(pathTo..images[6],(player(id,"tilex"))*32+16,(player(id,"tiley")-2)*32+16,3)
					tmpLevel[player(id,"tiley")-1][player(id,"tilex")+1]=5
				else
					imgLocation[player(id,"tilex").." "..player(id,"tiley")-2]=image(pathTo..images[4],(player(id,"tilex"))*32+16,(player(id,"tiley")-2)*32+16,3)
					tmpLevel[player(id,"tiley")-1][player(id,"tilex")+1]=3
				end
			end
		end
	elseif player(id,"rot")>=45 and player(id,"rot")<=135 then
		if tmpLevel[player(id,"tiley")+1][player(id,"tilex")+2]==3 or tmpLevel[player(id,"tiley")+1][player(id,"tilex")+2]==5 then
			if tmpLevel[player(id,"tiley")+1][player(id,"tilex")+3]==2 or tmpLevel[player(id,"tiley")+1][player(id,"tilex")+3]==4 then
				if tmpLevel[player(id,"tiley")+1][player(id,"tilex")+2]==5 then
					tmpLevel[player(id,"tiley")+1][player(id,"tilex")+2]=4
				else
					tmpLevel[player(id,"tiley")+1][player(id,"tilex")+2]=2
				end
				parse("killobject "..wallID(player(id,"tilex")+1,player(id,"tiley"),"id"))
				freeimage(imgLocation[(player(id,"tilex")+1).." "..player(id,"tiley")])
				imgLocation[(player(id,"tilex")+1).." "..player(id,"tiley")]=nil
				parse("spawnobject 4 "..(player(id,"tilex")+2).." "..player(id,"tiley"))
				if tmpLevel[player(id,"tiley")+1][player(id,"tilex")+3]==4 then
					imgLocation[(player(id,"tilex")+2).." "..player(id,"tiley")]=image(pathTo..images[6],(2+player(id,"tilex"))*32+16,player(id,"tiley")*32+16,3)
					tmpLevel[player(id,"tiley")+1][player(id,"tilex")+3]=5
				else
					imgLocation[(player(id,"tilex")+2).." "..player(id,"tiley")]=image(pathTo..images[4],(2+player(id,"tilex"))*32+16,player(id,"tiley")*32+16,3)
					tmpLevel[player(id,"tiley")+1][player(id,"tilex")+3]=3
				end
			end
		end
	elseif player(id,"rot")>=135 or player(id,"rot")<=-135 then
		if tmpLevel[player(id,"tiley")+2][player(id,"tilex")+1]==3 or tmpLevel[player(id,"tiley")+2][player(id,"tilex")+1]==5 then
			if tmpLevel[player(id,"tiley")+3][player(id,"tilex")+1]==2 or tmpLevel[player(id,"tiley")+3][player(id,"tilex")+1]==4 then
				if tmpLevel[player(id,"tiley")+2][player(id,"tilex")+1]==5 then
					tmpLevel[player(id,"tiley")+2][player(id,"tilex")+1]=4
				else
					tmpLevel[player(id,"tiley")+2][player(id,"tilex")+1]=2
				end
				parse("killobject "..wallID(player(id,"tilex"),player(id,"tiley")+1,"id"))
				freeimage(imgLocation[(player(id,"tilex")).." "..player(id,"tiley")+1])
				imgLocation[(player(id,"tilex")).." "..player(id,"tiley")+1]=nil
				parse("spawnobject 4 "..(player(id,"tilex")).." "..player(id,"tiley")+2)
				if tmpLevel[player(id,"tiley")+3][player(id,"tilex")+1]==4 then
					imgLocation[player(id,"tilex").." "..player(id,"tiley")+2]=image(pathTo..images[6],(player(id,"tilex"))*32+16,(player(id,"tiley")+2)*32+16,3)
					tmpLevel[player(id,"tiley")+3][player(id,"tilex")+1]=5
				else
					imgLocation[player(id,"tilex").." "..player(id,"tiley")+2]=image(pathTo..images[4],(player(id,"tilex"))*32+16,(player(id,"tiley")+2)*32+16,3)
					tmpLevel[player(id,"tiley")+3][player(id,"tilex")+1]=3
				end
			end
		end
	elseif player(id,"rot")>=-135 and player(id,"rot")<=-45 then
		if tmpLevel[player(id,"tiley")+1][player(id,"tilex")]==3 or tmpLevel[player(id,"tiley")+1][player(id,"tilex")]==5 then
			if tmpLevel[player(id,"tiley")+1][player(id,"tilex")-1]==2 or tmpLevel[player(id,"tiley")+1][player(id,"tilex")-1]==4 then
				if tmpLevel[player(id,"tiley")+1][player(id,"tilex")]==5 then
					tmpLevel[player(id,"tiley")+1][player(id,"tilex")]=4
				else
					 tmpLevel[player(id,"tiley")+1][player(id,"tilex")]=2
				end
				parse("killobject "..wallID(player(id,"tilex")-1,player(id,"tiley"),"id"))
				freeimage(imgLocation[(player(id,"tilex")-1).." "..player(id,"tiley")])
				imgLocation[(player(id,"tilex")-1).." "..player(id,"tiley")]=nil
				parse("spawnobject 4 "..(player(id,"tilex")-2).." "..player(id,"tiley"))
				if tmpLevel[player(id,"tiley")+1][player(id,"tilex")-1]==4 then
					imgLocation[(player(id,"tilex")-2).." "..player(id,"tiley")]=image(pathTo..images[6],(player(id,"tilex")-2)*32+16,player(id,"tiley")*32+16,3)
					tmpLevel[player(id,"tiley")+1][player(id,"tilex")-1]=5
				else
					imgLocation[(player(id,"tilex")-2).." "..player(id,"tiley")]=image(pathTo..images[4],(player(id,"tilex")-2)*32+16,player(id,"tiley")*32+16,3)
					tmpLevel[player(id,"tiley")+1][player(id,"tilex")-1]=3
				end
			end
		end
	end
	for _,row in ipairs(tmpLevel) do
		for _,block in ipairs(row) do
			if block==4 then
				return
			end
		end
	end
	parse("restart 5")
	msg(string.char(169).."255255255CONGRATULATIONS! You have beat level: "..level.." !@C")
	timer(4999,"dofile","maps/warehouse_keeper.lua")
end
addhook("spawn","_spawn")
function _spawn(id)
	parse("equip "..id.." 78")
	parse("setweapon "..id.." 78")
	parse("strip "..id.." 1")
	parse("strip "..id.." 2")
	parse("strip "..id.." 74")
	parse("strip "..id.." 50")
	parse("setpos "..id.." "..(spawn[1]*32+16).." "..(spawn[2]*32+16))
end
function wallID(x,y)
	for _,obj in ipairs(object(0,"table")) do
		if object(obj,"tilex")==x and object(obj,"tiley")==y then
			if object(obj,"type")==4 then
				return obj
			end
		end
	end
	return false
end
addhook("die","ware.die")
function ware.die()
	parse("restart")
	dofile("maps/warehouse_keeper.lua")
end
ware.startround()